"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Tengxunyun = void 0;
const axios_1 = __importDefault(require("axios"));
const decorator_1 = require("../../decorator");
const base_1 = require("../base");
const cheerio_1 = __importDefault(require("cheerio"));
const sitdown_1 = require("sitdown");
const sitdown = new sitdown_1.Sitdown({
    keepFilter: ['style'],
    codeBlockStyle: 'fenced',
    bulletListMarker: '-',
    hr: '---',
});
class Tengxunyun extends base_1.Base {
    constructor() {
        super(...arguments);
        this.headers = {};
        this.articleMap = new Map();
    }
    getMain() {
        var _a;
        return __awaiter(this, void 0, void 0, function* () {
            let page = 1;
            let ids = [];
            while (true) {
                const { data: res } = yield axios_1.default.post('https://cloud.tencent.com/developer/services/ajax/user-center?action=FetchUserArticles', {
                    action: 'FetchUserArticles',
                    payload: {
                        pageNumber: page++,
                        pageSize: 20,
                        uid: this.config.userId,
                    },
                });
                if (res.code === 0 && ((_a = res.data) === null || _a === void 0 ? void 0 : _a.list.length) > 0) {
                    res.data.list.forEach((x) => {
                        var _a;
                        ids.push(x.articleId);
                        this.articleMap.set(x.articleId, {
                            tags: x.tags.map((xx) => xx.name),
                            title: x.title,
                            date: new Date(x.writeTime * 1000).toLocaleDateString(),
                            categories: [(_a = x.column) === null || _a === void 0 ? void 0 : _a.name],
                        });
                    });
                }
                else if (res.data.list.length === 0) {
                    break;
                }
            }
            return ids;
        });
    }
    getDetail(id) {
        return __awaiter(this, void 0, void 0, function* () {
            const { data: html } = yield axios_1.default.get(` https://cloud.tencent.com/developer/article/${id} `);
            const $ = cheerio_1.default.load(html, {
                decodeEntities: true,
            });
            const content = sitdown.HTMLToMD($('.com-markdown-collpase').html());
            const item = this.articleMap.get(id);
            return Object.assign({ content }, item);
        });
    }
}
__decorate([
    decorator_1.catchCount()
], Tengxunyun.prototype, "getDetail", null);
exports.Tengxunyun = Tengxunyun;
//# sourceMappingURL=index.js.map